package Ightaria;


import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.applet.*;
import java.lang.Math;
import java.util.StringTokenizer;
import java.io.*;       //Only to read from URL.
import java.net.*;      //Only to read from URL.


import DrawTexts.*;
import CalculusAndVectors.*;
import Globals.*;
import Statistics.Stat;







//********************************************
//********************************************
//    C   L   A   S  S
//********************************************
//********************************************

public class Vessel extends    Applet 
                    implements Runnable, 
                               KeyListener, 
                               MouseListener {



/** Program state detection variables.
    Used to detect stops/initializations/reloads/cleanups.
*/
           static  int nonInitializedInt;
           static SPad nonInitializedSPad;
           static  int initializedInt = 2;
    public static  int initializedClearly = 2;



/**<pre>************************************************************

   Preinit variables.
   First declare variables which will have default values before
   init() or main() methods.
   Later, this values can be modified by input from disk at startup.

********************************************************************</pre>*/

   /** This dimensions can be supplied
       as applet parameters from web page 
       and can decrease the size of main 
       picture. 
       Look like toy parameters.          */ private int dimensionX =1000, dimensionY =700;
   /** Actual gabarite of Applet          */ private Dimension mainScrDimension;  
   /** Intended delay between animaiton
       frames                             */ int delay;

   /** Initial value.  With speed 20 
       frames/second program can run for 
       do1 put in internalInit or drop:
       4 years.                           */        static final int frameNumberStart = 1; 
   /** Frames counter                     */ public static int frameNumber = frameNumberStart;     
   /** From load      */                     public static int frNuFromLoad = 1;


//End of preinit variables.





//Init variables. This variables are set at init event:

static Applet thisApplet;
static    URL codebase;
Thread paintThread;
private static Image    parentImage;
private static Graphics parentGraphics;
Font dflFont;          
Font dflNavigationFont;

private  int imageInitFlag;
Bridge   br;



//RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
//Variables which begin to change after run method and
//their constants.
//======================================================

  /** This value will dispose graphics and thread when Applet stops */
  private static final      int RUN_SCENARIO_RELEASE_AT_STOP = 0; 

  private static final int RUN_SCENARIO_DONT_RELEASE_AT_STOP = 1;

  /** Set this constant at run-time. */
  private static final                      int RUN_SCENARIO = 0;

  private static              int stateOfRun = 0;
  private static final String[] STATE_OF_RUN = {
                "not-stopped", "stops", "frame-finished", 
                "restarts", "reruns"
          };



  //Frame cycle event variables
  static final int FC_ImageIsPainted = 0;
  static final int FC_ImageIsConstructing = 1;
  static final int FC_ImageIsConstructed = 2;
  static final int FC_ImageIsDrawing = 3;
  static final int FC_ImageIsDrawn = 4;
  static final int FC_ImageIsPainting = 5;
  int FrameCycle = FC_ImageIsPainted;  //Vital to set.

  //Auxilaray research parameters:
  long timeLeftAfterCalculations;
  long reconstructionTime;
  long startTime;
  long repaintStartTime;
  long repaintTime;
  String focus_Grant=" "; //Further values do not affect correct execution.
  
  public  int     keyID;         
  public  int     keyCode;       
  public  char    keyChar;       
  public  int     keyModifiers;
  /** Super initialization variable: */
  public  int     nonActivityIntervalInFrames=1000000;


  //-------------------------------------------
  // E x p e r i m e n t s
  //- - - - - - - - - - - - - - - - - - - - - - 
        private static int expmtNonFocusable   = 0;
        private static int expmtNonDisplayable = 0;
        private static int expmtNonVisible     = 0;
        private static int expmtRequestedFocus = 0;
        /** Used only once */  
        private static boolean focusOnKeyBoardRequested = false;
  //- - - - - - - - - - - - - - - - - - - - - - 
  // E x p e r i m e n t s
  //-------------------------------------------


//RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR













//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
//	init 
//=======================================================================
public void init() {

  String str;

  if( GS.mainLogPos != -1 ) {
      GS.mainLogPos = -1;
      GS.mainLogFilled = false;
      GS.con("Unclean beginning of Applet method init() ... ");
      GS.con("To clean, GS.mainLog parameters has been reinitialized ...");
  } 
  GS.con("Applet method init() begins ... ");


  //============================================================
  //Detection of run-state:

  //For this
  if( nonInitializedInt == 2 ) {
      GS.con("Vessel.nonInitializedInt is alerady = 2");
      initializedClearly = 3;
  //}else{
  //    GS.con("Vessel.nonInitializedInt is correct and = " + nonInitializedInt);
  }
  if( nonInitializedSPad != null ) {
      GS.con("Vessel.nonInitializedSPad is not null");
      initializedClearly = 3;
  //}else{
  //   GS.con("Vessel.nonInitializedSPad is correctly = null = " + nonInitializedSPad);
  }
  if( initializedInt != 2 ) {
      GS.con("Vessel.initializedInt is not cleaned. = " + initializedInt + ", not 2.");
      initializedClearly = 3;
  //}else{
  //    GS.con("Vessel.initializedInt is correctly = 2 = " + initializedInt);
  }


  //For some "static" class:
  if( Scenario.nonInitializedInt == 2 ) {
      GS.con("Scenario.nonInitializedInt is alerady = 2");
      initializedClearly = 3;
  //}else{
  //    GS.con("Scenario.nonInitializedInt is correct and = " + Scenario.nonInitializedInt);
  }
  if( !(Scenario.nonInitializedSPad == null) ) {
      GS.con("Scenario.nonInitializedSPad is not null");
      initializedClearly = 3;
  //}else{
  //    GS.con("Scenario.nonInitializedSPad is correctly = null = " + Scenario.nonInitializedSPad);
  }
  if( Scenario.initializedInt != 2 ) {
      GS.con("Scenario.initializedInt is not cleaned. = " + initializedInt + ", not 2.");
      initializedClearly = 3;
  //}else{
  //    GS.con("Scenario.initializedInt is correctly = 2 = " + Scenario.initializedInt);
  }
  if( 3 == initializedClearly ) {
      GS.con("Variables not reninitialized. Keep values changed in previous execution.");
  }else{
      GS.con("No unclean variable initialization detected ...");
  }

  nonInitializedInt  = 2;
  nonInitializedSPad = new SPad(SPad.F_, 0,    0,200,200);
  initializedInt     = 3;
  //============================================================


  thisApplet = this;

  //==================================================
  Stat.internalInit();
  SPad.internalInit();
  //==================================================


  //Set debug mode from web page if any.
  str = getParameter("debug");
  try { if (str != null )  {
            GS.deb = (  str.equalsIgnoreCase("true") ? true : false  );
        }
  } catch (Exception e) {}
  

  //=====================================================================
  // SET DEFAULT FONTS
  //---------------------------------------------------------------------
  GS.con("Getting Fonts ... ");

  dflFont = null;
  dflNavigationFont = null;

  GraphicsEnvironment ge = 
                      GraphicsEnvironment.getLocalGraphicsEnvironment();
  String FontList[] = ge.getAvailableFontFamilyNames();
  //con(FontList);
  for( int i=0; i<FontList.length; i++) {
       if(FontList[i].equalsIgnoreCase("COURIER NEW")) {
          dflNavigationFont = new Font(FontList[i],Font.BOLD,14);
          GS.defaultMonospacedFontName = dflNavigationFont.getName();
       } 
       if(FontList[i].equalsIgnoreCase("ARIAL")) {
          dflFont = new Font(FontList[i],Font.PLAIN,12);
          GS.defaultFontName = dflFont.getName();
       }
       if(dflFont != null && dflNavigationFont != null) break;
  }
  if( dflNavigationFont == null ) {
      for( int i=0; i<FontList.length; i++) {
           if(FontList[i].equalsIgnoreCase("MONOSPACED")) {
              dflNavigationFont = new Font(FontList[i],Font.PLAIN,14);
              GS.defaultMonospacedFontName = dflNavigationFont.getName();
              break;
           } 
      }
  }
  //con("Default Navigation Panel Font is set to: " + dflNavigationFont);
  ge = null;
  FontList = null;



  //---------------------------------------------------------------------
  // SET DEFAULT FONTS
  //=====================================================================




  




  //======================================================================================
  GS.con("Getting remaining parameters from Web Page ... ");
  //--------------------------------------------------------------------------------------

  Stat.initServerLanguage(getParameter("server_language"));

  double principalScale=1.;
  String sPrincipalScale = getParameter("PrincipalScale");

  str = getParameter("delay"); //Milliseconsd intended between frames.

  try { if (sPrincipalScale != null ) principalScale = Double.parseDouble(sPrincipalScale);
        if (str             != null ) delay          = Integer.parseInt(str);
  }
  catch (Exception e) {GS.con(e.toString());}

  str = getParameter("DimensionX");
  try { if (str != null ) dimensionX = Integer.parseInt(str);} catch (Exception e) {}
  str = getParameter("DimensionY");
  try { if (str != null ) dimensionY = Integer.parseInt(str);} catch (Exception e) {}

  if( principalScale > 2. ) {
      //The formula used by priests in ancient times to hide information
      //from non-devout person. We don't practice this tradition, but
      //in this occation, have to follow data interface compatibility:
      principalScale += 20.;
      principalScale  = 4.*(5000.+principalScale*principalScale*principalScale);
      HFold.hfRadius = principalScale;
  }


  //Get parameter to define use of jar for resources.
  boolean useJarForResources = false;
  str = getParameter("jar");
  try { if (str != null )  {
           useJarForResources = (  str.equalsIgnoreCase("true") ? true : false  );
        }
  } catch (Exception e) {}


  //--------------------------------------------------------------------------------------
  //  GS.con("Getting remaining parameters from Web Page ... ");
  //======================================================================================



  //GS.con("Creating Bridge instance ... ");  
  br = new Bridge();


  //Add more controls to Applet.
  addMouseListener( this );
  GS.con("Adding Key Listener ... ");  
  addKeyListener( this );


  //Getting files backbone.

  int typeOfResource = useJarForResources ?  1: 0 ;
  codebase = getCodeBase();

  GU.getResource(codebase, "QuickHelp.txt", typeOfResource, this);
  Scenario.quickHelp        = GU.resource;
  Scenario.quickHelpLength  = GU.resourceLength;

  GU.getResource(codebase, "Help.txt", typeOfResource, this);
  Scenario.help        = GU.resource;
  Scenario.helpLength  = GU.resourceLength;

  GU.getResource(codebase, "Introduction.txt", typeOfResource, this);
  Scenario.introduction  = GU.resource;
  Scenario.introductionLength = GU.resourceLength;

  GU.getResource(codebase, "Level1Help.txt", typeOfResource, this);
  Scenario.level1Help  = GU.resource;
  Scenario.level1HelpLength = GU.resourceLength;

  GU.getResource(codebase, "Story.txt", typeOfResource, this);
  Scenario.story       = GU.resource;
  Scenario.storyLength = GU.resourceLength;


  //Now, get images in simple way:
  for( int j=1; j<Scenario.sketchImg.length; j++ ) {
       if( Scenario.sketchImg[j] != null ) {
           for( int i=0; i<Scenario.sketchImg[j].length; i++ ) {
                Scenario.sketchImg[j][i] = getImage( 
                       codebase, "Resources/sketch" + j + "_" + i + ".gif");
                Scenario.sketchImgObs[j][i] = (ImageObserver) this;
           }
       }  
  }



  /*
  MediaTracker mt = new MediaTracker();
  
  for( int i=0; i<Scenario.Image.length; i++ ) {
       Scenario.level2ImgHelp[i] = Toolkit.getDefaultToolkit.getImage( 
                          "Resources/lev1_hlp" + i + ".gif");
       mt.addImage( Scenario.level2ImgHelp[i], i );
  }
  */

  GS.con("Applet method init() completed.");
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII













//RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR
// 		RUN
//=================================================================
public void run() {


  

 
  try {

    while( Thread.currentThread() == paintThread ) {

    if( 1 == stateOfRun ) {
        stateOfRun = 2;
        GS.con(paintThread.getName() + " SOR = " + STATE_OF_RUN[stateOfRun]);
        GS.con("   Frame " + frameNumber + " finished, and next frame blocked.");
        //Hard scenario: discard thread for case of Applet's stop event
        paintThread = null; //do1b can we?
        return;
    }else if( 2 != stateOfRun ) {

        /*
        1 means that stop method fired and after completion of the while 
        cycle-element, new cycle-elements are not called which allows to
        clean up graphics and even to destroy a thread.
        */

       if( Bridge.exitORDERED == Bridge.exitFlag ) {
           Stat.supplyStat(2);  //2 - end of session
           //Terminate Application graciously:
           if( Bridge.exitLastFrame == frameNumber ) {
               GS.con("Exit sequence completed at frame " + frameNumber );
               Bridge.exitFlag = Bridge.exitCOMPLETED;  //Not used. For future Applet disposal.
               if( 1 == imageInitFlag ) releaseGraphics();
               paintThread = null;  //do1b can we?
               return;
           }
       }   


       if( 3 == stateOfRun ) {
           stateOfRun = 4;
           GS.con(paintThread.getName() + " SOR = " + STATE_OF_RUN[stateOfRun] + 
                  " SubFrame = " + FrameCycle);

           switch(FrameCycle) {
           case FC_ImageIsPainted:
                GS.con("Travel resumes from normal SubFrame. No intervention is required.");
                break;

           case FC_ImageIsConstructing:
                GS.con("Frame interrupted ... Cannot step back now ... ");
                GS.con("To continue reliably, reload the Applet ...");
                GS.con("... or continue in on your own risk ...");
                FrameCycle = FC_ImageIsPainted;
                break;

           case FC_ImageIsConstructed:           
           case FC_ImageIsDrawing:
           case FC_ImageIsDrawn:
           case FC_ImageIsPainting:
                GS.con("Paint or Update of Graphics did not complete in previous");
                GS.con("   SubFrame. Reinitializing to SubFrame ImageIsPainted.");
                FrameCycle = FC_ImageIsPainted;
           }

           //do1 Need step back to previous stop? Or reset one move back?

           //We not always have to clean this up:
           //But for clarity:
           br.MovedAndStoppedIsInProgress = false;
           br.keyEventHappened            = false;
           
           //No need to refresh these because they will be ignored now
           //and will be reset at next keyboard event:
           //keyCode      = e.getKeyCode();
           //keyID        = e.getID();
           //keyModifiers = e.getModifiersEx();
           //keyChar        is not used in Bridge

           focusOnKeyBoardRequested = false; //Appears vital to set.

       }        
            

       //Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
       long loReconstructionTime;

       if(FrameCycle == FC_ImageIsPainted) {

          FrameCycle           = FC_ImageIsConstructing;
          startTime            = System.currentTimeMillis();
          loReconstructionTime = System.currentTimeMillis();

          br.runFrameStep(       keyID,
                                 keyCode,     
                                 keyModifiers, 
                                 frameNumber
          );
          //This adds messages to preliminary set SPad.b_:
          vesselComputerMessages();

          SPad.drawPads();

          FrameCycle         = FC_ImageIsConstructed;
          reconstructionTime = System.currentTimeMillis() - loReconstructionTime;
          repaintStartTime   = System.currentTimeMillis();
          repaint();	             
          Stat.supplyStat(0); //Put this after repaint to save time.


          //====================================================================
          //  Keyboard focus
          //--------------------------------------------------------------------
          // click on vessel's screen if not responsive 
          if( nonActivityIntervalInFrames > 60 ) {
              if( (frameNumber % 20) == 3 ) {
                  requestFocus(); //Bully requester 
                  expmtRequestedFocus++;
              }

              if( !isFocusable() )   expmtNonFocusable++;
              if( !isDisplayable() ) expmtNonDisplayable++;
              if( !isVisible() )     expmtNonVisible++;
              focus_Grant = "F:r=" + expmtRequestedFocus + 
                            " D=" + expmtNonDisplayable  +
                            " V=" + expmtNonVisible      +
                            " F=" + expmtNonFocusable;
          }


          /* All in this comment block is in rank of an experiment:
           if( (frameNumber % 20) == 3 ) { //|| !focusOnKeyBoardRequested ) {
 
              //Hope, 2 seconds is not often to bother computer and
              //not rare to annoy user.
              focus_Grant = "Focus: ";
              if( isFocusable() ) {
                  focus_Grant += "F,";
                  if( isDisplayable() ) {
                      focus_Grant += "D,";
                      if( isVisible() ) {
                          focus_Grant += "V,";
                          //if( !focusOnKeyBoardRequested ) {
                              //focusOnKeyBoardRequested = requestFocusInWindow(); 
                              requestFocus();
                              focusOnKeyBoardRequested = true;
                              if( focusOnKeyBoardRequested ) {
                                  focus_Grant += "initiated ... ";
                              } //else {
                                //  focus_Grant += "not granted ... ";
                              //}
                              GS.con(focus_Grant);
                          //}else{
                          //    focus_Grant += "was initiated ... ";
                          //}
                      } else {
                          focus_Grant += "v, lost";
                          focusOnKeyBoardRequested = false;
                      }
                  } else {
                      focus_Grant += "d, lost";
                      focusOnKeyBoardRequested = false;
                  }
              } else {
                  focus_Grant += "f, lost";
                  focusOnKeyBoardRequested = false; 
             }
             //GS.con(focus_Grant);
           }
          */
          /*
          //Another method:
          if( !focusOnKeyBoardRequested ) {
              requestFocus(); //Without this, user must click on Applet
                              //to get keyboard available.
              focusOnKeyBoardRequested = true;
          }
          */
          //--------------------------------------------------------------------
          //  Keyboard focus
          //====================================================================

          

          startTime += delay;
          timeLeftAfterCalculations = startTime - System.currentTimeMillis();

          Thread.sleep(Math.max(0, timeLeftAfterCalculations));
          if(timeLeftAfterCalculations <=0 ) {startTime = System.currentTimeMillis(); };

      }
    } //if( 1 != stateOfRun ) {
    } //while
  } catch (InterruptedException e) {
  }
}//RRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRRR













//***********************
//    APPLET METHODS
//=======================

public void start() {

       GS.con(" ");
       GS.con("Applet begins start(). Run-Scenario=" + RUN_SCENARIO);
       GS.con("   SOR = " + STATE_OF_RUN[stateOfRun] + 
              " SubFrame = " + FrameCycle + " frameNumber=" + frameNumber + 
              " Level=" + Scenario.level + " " + Scenario.levelTitle[Scenario.level]);

       //Increase probablity of destroyed graphics detection:
       if( parentImage == null || parentGraphics == null) {
           GS.con("Background Graphics does not exist ... ");
           GS.con("Graphics in SPads probably destroyed also ... ");
           imageInitFlag = 0;
           //do1b assumption: 
           //  it is legal 
           //      1. to initialize background graphics in start() method and
           //      2. draw on this background graphics in start() method.
           //  The doubt raises from the impression that graphics   
           //  depends on parent object (Applet in this case) and
           //  cannot work until Applet's method run is normally   
           //  running. Similarly, the method requestFocus() apparently
           //  does not work until called from run():
           initializeGraphicsObjectsFromApplet();
       }

       if( 2 == imageInitFlag ) {
           GS.con("Cannot fix graphics object now ... ");
           GS.con("   Travel Thread will be terminated shortly ...");
           Bridge.exitFlag = Bridge.exitORDERED;
           Bridge.exitLastFrame = frameNumber;
       }

       if( 1 == stateOfRun ||
           2 == stateOfRun ) {
           stateOfRun = 3;
           GS.con("Setting SOR = " + STATE_OF_RUN[stateOfRun]);
           if( paintThread != null ) {
               GS.con("   Thread " + paintThread.getName() + " is alive.");
               //Apparently this does not work from method "start()":
               //repaint();
           }
       }

       if( paintThread == null ) {
           paintThread = new Thread(this); 
           paintThread.setName("Travel");
           GS.con(paintThread.getName() + " (re)created and starts ... ");
           paintThread.start();
           //This does not work: 
           //requestFocus(); 
       }

}

public void stop() {
      
      stateOfRun = 1;
      GS.con(" ");
      GS.con("Applet begins stop().");
      GS.con("   SOR=" + STATE_OF_RUN[stateOfRun] + 
                 " SubFrame=" + FrameCycle + 
                 " frameNumber=" + frameNumber + 
                 " Level=" + Scenario.level + " " + Scenario.levelTitle[Scenario.level]);
      Stat.supplyStat(1);  //Supply stat. in case applet destroys ...

      if( RUN_SCENARIO_RELEASE_AT_STOP == RUN_SCENARIO ) {

          //It seems bad to discard objects this way without
          //letting cycle to terminate.
          //Apparently, paintThread is still running and was crashed
          //on non-existing graphics at one test:

            //To wait 20 secs to let FrameCycle finish.
            //So long while message to server not in separate thread and blocks.
            long loThreshold = System.currentTimeMillis() + 20000;
                   //do1 check for available space to keep big time:
            while( stateOfRun != 2 ) {
                   if( loThreshold <= System.currentTimeMillis() ) {
                       GS.con("Tired to wait when FrameCycle finishes ... ");
                       GS.con("   Going to destroy graphics and thread ... ");
                       break;
                   }
            }
            //do1 correct?:
            if( 2 == stateOfRun ) 
                GS.con("Paint thread graciously finished its FrameCycle ... ");

            GS.con("Going to dispose thread and graphics ... ");
            //do1b Is this recommended?:
            paintThread = null;
            //do1b Is this recommended?:
            releaseGraphics();

      }
}


public void update(Graphics g) {

   if( stateOfRun == 4  ) {
       GS.con("Starting first paint/update after travel resumed.");
       stateOfRun = 0;
       GS.con("   SOR=" + STATE_OF_RUN[stateOfRun]);
   }

   if( FrameCycle == FC_ImageIsConstructed ) {
       FrameCycle = FC_ImageIsDrawing;

       if( dimensionX < mainScrDimension.width  &&
           dimensionY < mainScrDimension.height  ) {

           g.drawImage(parentImage, 0, 0, 
                       dimensionX,
                       dimensionY,
                       null);   //was "this);" in versions 1.0.1-1.0.10.

       } else {
           g.drawImage(parentImage, 0, 0, null); //was "this);" in versions 1.0.1-1.0.10.
       }

       FrameCycle = FC_ImageIsPainting;
    }

    paint(g);

    if( FrameCycle == FC_ImageIsPainting ) {
        FrameCycle = FC_ImageIsPainted;
        repaintTime = System.currentTimeMillis() - repaintStartTime;
        frameNumber++;
        nonActivityIntervalInFrames++;
        frNuFromLoad++;
    }

}

//public void paint(Graphics g) {
//       update(g);
//}

//=======================
//    APPLET METHODS
//***********************











//============================================================== 
// Keyboard Events
// Related flags are: br.MovedAndStoppedIsInProgress
//                    keyUpDownCode
//--------------------------------------------------------------
/** Main handler of stop-after-move event */
public void keyReleased( KeyEvent e ) { 
   
       int loKeyCode = e.getKeyCode();

       nonActivityIntervalInFrames = 0;

       /** Main handler of stop-after-move event */
       if( loKeyCode == KeyEvent.VK_DOWN || 
           loKeyCode == KeyEvent.VK_UP ) {
           br.MovedAndStoppedIsInProgress = true;
       }            
       e.consume();

}




/**<pre>
    This is main keyboard handler in Vessel.class 
    It makes preliminary check, 
       discards redundant/orphan keystrokes, 
       stores keys to be passed to upper keyhandler in Bridge, and
       immediately digests typing keys.
</pre>*/    
public void keyPressed( KeyEvent e ) { 

       keyCode      = e.getKeyCode();
       keyID        = e.getID();
       keyModifiers = e.getModifiersEx();

       nonActivityIntervalInFrames = 0;

       //-----------------------------------------
       //Block orphan envents:
       //- - - - - - - - - - - - - - - - - - - - - 
       if( br.keyEventHappened ) { 
           //Bridge is still processing keyEvent ...
           //GS.con("Discarding KEY becaue keyEventHappened.");
           e.consume();
           return;
       } 
       if( br.MovedAndStoppedIsInProgress ) {
           //GS.con("-Discarding because MovedAndStoppedInProgress.");
           e.consume();
           return;
       }
       //- - - - - - - - - - - - - - - - - - - - - 
       //Block orphan envents:
       //-----------------------------------------

       //GS.con("KEY="  + keyCode + "."  + keyID + 
       //       " MS="  + br.MovedAndStoppedIsInProgress + ".");


       //--------------------------------------------------------------
       // Parse (movement) arrow events 
       //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
       if (keyCode == KeyEvent.VK_DOWN || keyCode == KeyEvent.VK_UP ) {
           br.keyEventHappened = true;
           e.consume();
           return;
       }  
       //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
       // Parse (movement) arrow events 
       //--------------------------------------------------------------


       //-----------------------------------------------------
       //Handle text-typing events 
       //Note: as of today, typing is not blocked when no
       //      movement activity.
       //      The keys in this block digested immediately.
       //      In other words, they are not passed to Bridge. 
       //- - - - - - - - - - - - - - - - - - - - - - - - - - -
       switch(keyCode) {
          case KeyEvent.VK_DOWN :
          case KeyEvent.VK_UP :
          case KeyEvent.VK_LEFT :
          case KeyEvent.VK_RIGHT :
          case KeyEvent.VK_PAGE_DOWN :
          case KeyEvent.VK_PAGE_UP :
               break;
          default:
            //if( keyID == KeyEvent.KEY_TYPED) {
            if( keyModifiers != KeyEvent.CTRL_DOWN_MASK &&
                keyModifiers != KeyEvent.ALT_DOWN_MASK  ) {

                //In this block, to pass events to Bridge, 
                //one has to add br.keyEventHappened = true;

                //Simple typing. Quickly add to buffer ...
                if( SPad.focusIx != SPad.none_ ) {
                    keyChar = e.getKeyChar();
                    if( ((int) keyChar ) < 127 &&
                        ((int) keyChar ) > 31 ) {
                        SPad.sPad[SPad.focusIx].addChar(keyChar);
                    } else {
                        switch(keyCode) {
                        case KeyEvent.VK_ENTER:
                             br.keyEventHappened = true;
                             break;
                        case KeyEvent.VK_BACK_SPACE:
                             SPad.sPad[SPad.focusIx].removeChar();
                             break;
                        } 
                    }  
                }

                if( keyCode == KeyEvent.VK_ESCAPE ) {
                    br.keyEventHappened = true;
                    //GS.con("Escape. keyCode=" + keyCode);
                }
                e.consume();
                return; 
            }           
       }
       //- - - - - - - - - - - - - - - - - - - - - - - - - - -
       //Handle text-typing events 
       //-----------------------------------------------------
       br.keyEventHappened = true;
       //GS.con("-Setting KEH." + " char=" + keyChar + " keyCode=" + keyCode);
       e.consume();
       return;
}

/** I would not able to make this proc. useful */
public void keyTyped( KeyEvent e ) {
}


   public void mouseEntered( MouseEvent e ) { }
   public void mouseExited( MouseEvent e ) { }
   public void mousePressed( MouseEvent e ) { }
   public void mouseReleased( MouseEvent e ) { }

   public void mouseClicked( MouseEvent e ) {
      //x = e.getX();
      //y = e.getY();
      e.consume();
   }






void vesselComputerMessages() {
  SPad sPb = SPad.sPad[SPad.b_]; 
  sPb.foreTextColor = SPad.BRIGHT_BLUED;
  sPb.wr("Vessel computer resources:");
  sPb.wr("  Frame Number=" + frameNumber);
  sPb.wr("  Interval=" + delay);
  sPb.wr("  Reconstruction =" + reconstructionTime);
  sPb.wr("  Repaint =" + repaintTime);
  sPb.wr("  Spare =" + timeLeftAfterCalculations);
  sPb.wr(focus_Grant); //do1b Make nice prompt for user: click on scr to get focus ...
}



private void releaseGraphics() {
        parentImage    = null;
        parentGraphics = null;
        br.releaseGraphics();
        GS.con("All background Graphics set to null");
}


private void initializeGraphicsObjectsFromApplet() {

   try { 

         GS.con("Creating main buffer graphics ... ");
         mainScrDimension = getSize();
         parentImage      = createImage(mainScrDimension.width,
                                        mainScrDimension.height);
         if( parentImage == null ) {
             imageInitFlag = 2; //Failed
             GS.con("Cannot create parentImage");
             return;
         }
         parentGraphics   = parentImage.getGraphics();
         if( parentGraphics == null ) {
             imageInitFlag = 2; //Failed
             GS.con("Cannot create parentGraphics");
             return;
         }

         //-------------------------------------------------------------
         // Supply graphics to Scratch Pads
         //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -      
         GS.con("Initializing Scratch Pads graphics ... ");
         Image img;
         Graphics g;
         //SPad.supplyParentGraphicsToCollection( parentImage,
         //                                       parentGraphics,
         //                                       (ImageObserver) this
         //                                     );
         for(int i=0; i<SPad.sPad.length; i++) {
             if( SPad.sPad.length - 1 == i ) {
                 SPad.supplyGraphicsToCollection( i, parentImage, parentGraphics,
                                                  (ImageObserver) this,
                                                  dflFont );
             } else { 
                 img = createImage(SPad.sPad[i].xL, SPad.sPad[i].yL);
                 if( img == null ) GS.con("Cannot create Image for SPad " + i );
                 g   = img.getGraphics();
                 if( g == null ) GS.con("Cannot create Graphics for SPad " + i );
                 SPad.supplyGraphicsToCollection(i, img, g,(ImageObserver) this, dflFont);
             }
         }
         g   = null;
         img = null;
         if( dflNavigationFont != null ) {
             SPad.sPad[SPad.S_].setDefaultFont(dflNavigationFont); 
         }
         //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -      
         // Supply graphics to Scratch Pads
         //-------------------------------------------------------------
 
         br.supplyGraphics();

         imageInitFlag = 1; //Success
         GS.con("All Graphics objects created succesfully. ");

    } catch( Throwable e ) {
             imageInitFlag = 2; //Failed
             GS.con("Problems to create graphics objects:" + e);
    }
 }



static public String getServerResource(String relativePath) {
       //do1b:
       //Slow?. "Incapsulation" causes slow code?
       //Must? reuse public var? 
       return GU.getResource(codebase, relativePath, 2, thisApplet);
}



public String getAppletInfo() {
       return ( Scenario.COPYRIGHT[0] + "\n" + 
                Scenario.COPYRIGHT[1] + "\n" + 
                Scenario.COPYRIGHT[2]
       );
}


} //Applet End